module Uricp::Strategy
  class Cleaner
    include Uricp::Strategy::Common

    def appropriate?
      return proposal if options['clean'] && sequence_complete?

      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "rm -f #{options['clean'].join(' ')};"
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options.delete('clean')
      self
    end
  end
end
