module Uricp::Strategy
  class LocalLink
    include Uricp::Strategy::Common

    def appropriate?
      return proposal if !compression_required? &&
                         all_local_files? &&
                         !format_change? &&
                         linkable?

      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "ln -fT #{from.path} #{to.path};"
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options['from_uri'] = @proposed_options['to_uri']
      self
    end

    def linkable?
      from_path_dir = File.dirname(from.path)
      to_path_dir = File.dirname(to.path)
      File.directory?(from_path_dir) && File.directory?(to_path_dir) &&
        File.stat(from_path_dir).dev == File.stat(to_path_dir).dev &&
        (!File.exist?(to.path) || File.file?(to.path))
    end
  end
end
