module Uricp::Strategy
  class PipedCompress
    include Uricp::Strategy::Common

    def appropriate?
      case from.scheme
      when 'pipe'
        return proposal if compression_required?
      end
      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      'lz4 |'
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options.delete('compress')
      @proposed_options['encoding'] = 'lz4'
      self
    end
  end
end
