module Uricp::Strategy
  class PipedLocalCompress
    include Uricp::Strategy::Common

    def appropriate?
      case from.scheme
      when 'file'
        return proposal if !sequence_complete? && compression_required?
      end
      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "lz4 -c <'#{from.path}' |"
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options.delete('compress')
      @proposed_options['encoding'] = 'lz4'
      @proposed_options['from_uri'] = PIPE_URI
      self
    end
  end
end
