module Uricp::Strategy
  class PipedLocalGet
    include Uricp::Strategy::Common

    def appropriate?
      case from.scheme
      when 'file'
        return proposal unless sequence_complete?
      end
      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "< '#{from.path}' "
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options['from_uri'] = PIPE_URI
      self
    end
  end
end
