module Uricp::Strategy
  class PipedLocalPut
    include Uricp::Strategy::Common

    def appropriate?
      return proposal if to.scheme == 'file' &&
                         from.scheme == 'pipe'

      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "cp --sparse=always /dev/stdin #{to.path};"
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options['from_uri'] = @proposed_options['to_uri']
      self
    end
  end
end
