module Uricp::Strategy
  class RbdSweeper
    include Uricp::Strategy::Common

    def appropriate?
      return proposal if options['rbd_snapshot'] && sequence_complete?

      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      "rbd snap rm --id #{rbd_id} '#{options['rbd_snapshot']}';"
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options.delete('rbd_snapshot')
      self
    end
  end
end
