module Uricp::Strategy
  class RemotePut
    include Uricp::Strategy::Common

    def appropriate?
      if compression_required? || conversion_required?
        debug "#{self.class.name}: not ready to upload"
        return false
      end
      case to.scheme
      when 'http', 'https'
        case from.scheme
        when 'file', 'pipe'
          return proposal if http_authentication?

          unsupported_transfer
        end
      end
      debug "#{self.class.name}: not appropriate"
      false
    end

    def command
      curl_upload_from(curl_source)
    end

    def proposal
      @proposed_options = options.dup
      @proposed_options['from_uri'] = to
      self
    end

    def curl_source
      if from.scheme == 'pipe'
        '-'
      else
        from.path
      end
    end
  end
end
